"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var prop_types_1 = __importDefault(require("prop-types"));
var classnames_1 = __importDefault(require("classnames"));
var Card_1 = __importDefault(require("@material-ui/core/Card"));
var Avatar_1 = __importDefault(require("@material-ui/core/Avatar"));
var styles_1 = require("@material-ui/core/styles");
var Lock_1 = __importDefault(require("@material-ui/icons/Lock"));
var defaultTheme_1 = __importDefault(require("../defaultTheme"));
var Notification_1 = __importDefault(require("../layout/Notification"));
var LoginForm_1 = __importDefault(require("./LoginForm"));
var styles = function (theme) { return ({
    main: {
        display: 'flex',
        flexDirection: 'column',
        minHeight: '100vh',
        height: '1px',
        alignItems: 'center',
        justifyContent: 'flex-start',
        background: 'url(https://source.unsplash.com/random/1600x900)',
        backgroundRepeat: 'no-repeat',
        backgroundSize: 'cover',
    },
    card: {
        minWidth: 300,
        marginTop: '6em',
    },
    avatar: {
        margin: '1em',
        display: 'flex',
        justifyContent: 'center',
    },
    icon: {
        backgroundColor: theme.palette.secondary[500],
    },
}); };
var sanitizeRestProps = function (_a) {
    var classes = _a.classes, className = _a.className, location = _a.location, title = _a.title, array = _a.array, theme = _a.theme, staticContext = _a.staticContext, rest = __rest(_a, ["classes", "className", "location", "title", "array", "theme", "staticContext"]);
    return rest;
};
/**
 * A standalone login page, to serve as authentication gate to the admin
 *
 * Expects the user to enter a login and a password, which will be checked
 * by the `authProvider` using the AUTH_LOGIN verb. Redirects to the root page
 * (/) upon success, otherwise displays an authentication error message.
 *
 * Copy and adapt this component to implement your own login logic
 * (e.g. to authenticate via email or facebook or anything else).
 *
 * @example
 *     import MyLoginPage from './MyLoginPage';
 *     const App = () => (
 *         <Admin loginPage={MyLoginPage} authProvider={authProvider}>
 *             ...
 *        </Admin>
 *     );
 */
var Login = function (_a) {
    var classes = _a.classes, className = _a.className, loginForm = _a.loginForm, rest = __rest(_a, ["classes", "className", "loginForm"]);
    return (react_1.default.createElement("div", __assign({ className: classnames_1.default(classes.main, className) }, sanitizeRestProps(rest)),
        react_1.default.createElement(Card_1.default, { className: classes.card },
            react_1.default.createElement("div", { className: classes.avatar },
                react_1.default.createElement(Avatar_1.default, { className: classes.icon },
                    react_1.default.createElement(Lock_1.default, null))),
            loginForm),
        react_1.default.createElement(Notification_1.default, null)));
};
Login.propTypes = {
    className: prop_types_1.default.string,
    authProvider: prop_types_1.default.func,
    classes: prop_types_1.default.object,
    input: prop_types_1.default.object,
    meta: prop_types_1.default.object,
    previousRoute: prop_types_1.default.string,
    loginForm: prop_types_1.default.element,
};
Login.defaultProps = {
    theme: defaultTheme_1.default,
    loginForm: react_1.default.createElement(LoginForm_1.default, null),
};
exports.default = styles_1.withStyles(styles)(Login);
