"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var prop_types_1 = __importDefault(require("prop-types"));
var react_redux_1 = require("react-redux");
var classnames_1 = __importDefault(require("classnames"));
var react_router_1 = require("react-router");
var styles_1 = require("@material-ui/core/styles");
var compose_1 = __importDefault(require("recompose/compose"));
var AppBar_1 = __importDefault(require("./AppBar"));
var Sidebar_1 = __importDefault(require("./Sidebar"));
var Menu_1 = __importDefault(require("./Menu"));
var Notification_1 = __importDefault(require("./Notification"));
var Error_1 = __importDefault(require("./Error"));
var defaultTheme_1 = __importDefault(require("../defaultTheme"));
var styles = function (theme) {
    var _a;
    return ({
        root: {
            display: 'flex',
            flexDirection: 'column',
            zIndex: 1,
            minHeight: '100vh',
            backgroundColor: theme.palette.background.default,
            position: 'relative',
            minWidth: 'fit-content',
            width: '100%',
        },
        appFrame: {
            display: 'flex',
            flexDirection: 'column',
        },
        contentWithSidebar: {
            display: 'flex',
            flexGrow: 1,
        },
        content: (_a = {
                display: 'flex',
                flexDirection: 'column',
                flexGrow: 1,
                padding: theme.spacing.unit * 3
            },
            _a[theme.breakpoints.up('xs')] = {
                paddingLeft: 5,
            },
            _a[theme.breakpoints.down('sm')] = {
                padding: 0,
            },
            _a),
    });
};
var sanitizeRestProps = function (_a) {
    var staticContext = _a.staticContext, history = _a.history, location = _a.location, match = _a.match, props = __rest(_a, ["staticContext", "history", "location", "match"]);
    return props;
};
var Layout = /** @class */ (function (_super) {
    __extends(Layout, _super);
    function Layout(props) {
        var _this = _super.call(this, props) || this;
        _this.state = { hasError: false, errorMessage: null, errorInfo: null };
        /**
         * Reset the error state upon navigation
         *
         * @see https://stackoverflow.com/questions/48121750/browser-navigation-broken-by-use-of-react-error-boundaries
         */
        props.history.listen(function () {
            if (_this.state.hasError) {
                _this.setState({ hasError: false });
            }
        });
        return _this;
    }
    Layout.prototype.componentDidCatch = function (errorMessage, errorInfo) {
        this.setState({ hasError: true, errorMessage: errorMessage, errorInfo: errorInfo });
    };
    Layout.prototype.render = function () {
        var _a = this.props, appBar = _a.appBar, children = _a.children, classes = _a.classes, className = _a.className, customRoutes = _a.customRoutes, error = _a.error, dashboard = _a.dashboard, logout = _a.logout, menu = _a.menu, notification = _a.notification, open = _a.open, sidebar = _a.sidebar, title = _a.title, props = __rest(_a, ["appBar", "children", "classes", "className", "customRoutes", "error", "dashboard", "logout", "menu", "notification", "open", "sidebar", "title"]);
        var _b = this.state, hasError = _b.hasError, errorMessage = _b.errorMessage, errorInfo = _b.errorInfo;
        return (react_1.default.createElement("div", __assign({ className: classnames_1.default('layout', classes.root, className) }, sanitizeRestProps(props)),
            react_1.default.createElement("div", { className: classes.appFrame },
                react_1.createElement(appBar, { title: title, open: open, logout: logout }),
                react_1.default.createElement("main", { className: classes.contentWithSidebar },
                    react_1.createElement(sidebar, {
                        children: react_1.createElement(menu, {
                            logout: logout,
                            hasDashboard: !!dashboard,
                        }),
                    }),
                    react_1.default.createElement("div", { className: classes.content }, hasError
                        ? react_1.createElement(error, {
                            error: errorMessage,
                            errorInfo: errorInfo,
                            title: title,
                        })
                        : children)),
                react_1.createElement(notification))));
    };
    return Layout;
}(react_1.Component));
var componentPropType = prop_types_1.default.oneOfType([
    prop_types_1.default.func,
    prop_types_1.default.string,
]);
Layout.propTypes = {
    appBar: componentPropType,
    children: prop_types_1.default.oneOfType([prop_types_1.default.func, prop_types_1.default.node]),
    classes: prop_types_1.default.object,
    className: prop_types_1.default.string,
    customRoutes: prop_types_1.default.array,
    dashboard: componentPropType,
    error: componentPropType,
    history: prop_types_1.default.object.isRequired,
    logout: prop_types_1.default.oneOfType([
        prop_types_1.default.node,
        prop_types_1.default.func,
        prop_types_1.default.string,
    ]),
    menu: componentPropType,
    notification: componentPropType,
    open: prop_types_1.default.bool,
    sidebar: componentPropType,
    title: prop_types_1.default.node.isRequired,
};
Layout.defaultProps = {
    appBar: AppBar_1.default,
    error: Error_1.default,
    menu: Menu_1.default,
    notification: Notification_1.default,
    sidebar: Sidebar_1.default,
};
var mapStateToProps = function (state) { return ({
    open: state.admin.ui.sidebarOpen,
}); };
var EnhancedLayout = compose_1.default(react_redux_1.connect(mapStateToProps, {}), react_router_1.withRouter, styles_1.withStyles(styles))(Layout);
var LayoutWithTheme = /** @class */ (function (_super) {
    __extends(LayoutWithTheme, _super);
    function LayoutWithTheme(props) {
        var _this = _super.call(this, props) || this;
        _this.theme = styles_1.createMuiTheme(props.theme);
        return _this;
    }
    LayoutWithTheme.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps.theme !== this.props.theme) {
            this.theme = styles_1.createMuiTheme(nextProps.theme);
        }
    };
    LayoutWithTheme.prototype.render = function () {
        var _a = this.props, theme = _a.theme, rest = __rest(_a, ["theme"]);
        return (react_1.default.createElement(styles_1.MuiThemeProvider, { theme: this.theme },
            react_1.default.createElement(EnhancedLayout, __assign({}, rest))));
    };
    return LayoutWithTheme;
}(react_1.Component));
LayoutWithTheme.propTypes = {
    theme: prop_types_1.default.object,
};
LayoutWithTheme.defaultProps = {
    theme: defaultTheme_1.default,
};
exports.default = LayoutWithTheme;
